VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Read Status of Running USB DPPs"
   ClientHeight    =   5925
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   5925
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picPlot 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   2655
      Left            =   120
      ScaleHeight     =   173
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   293
      TabIndex        =   5
      Top             =   3120
      Width           =   4455
   End
   Begin VB.TextBox txtDevNum 
      Enabled         =   0   'False
      Height          =   285
      Left            =   2400
      TabIndex        =   4
      Top             =   120
      Width           =   855
   End
   Begin VB.CommandButton cmdGetDevices 
      Caption         =   "Get Devices"
      Height          =   375
      Left            =   1080
      TabIndex        =   3
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton cmdClearStatus 
      Caption         =   "Clear Status"
      Height          =   375
      Left            =   3480
      TabIndex        =   2
      Top             =   120
      Width           =   1095
   End
   Begin VB.TextBox txtStatus 
      Height          =   2445
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   600
      Width           =   4455
   End
   Begin VB.CommandButton cmdGetData 
      Caption         =   "Get Data"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private iNumDevices As Integer

Private Sub cmdClearStatus_Click()
    txtStatus = ""
End Sub

Public Function ConvertDataToBuffer(NumChan As Integer, DataBuffer() As Long) As Variant
    Dim idxSpectrum As Integer
    Dim varData() As Long
    For idxSpectrum = 0 To NumChan - 1
        ReDim Preserve varData(idxSpectrum)
        varData(idxSpectrum) = DataBuffer(idxSpectrum)
    Next
    ConvertDataToBuffer = varData
End Function

Private Sub cmdGetData_Click()
    cmdGetData.Enabled = False      ' disable button until done
    Dim numdev As Integer           ' number of usb devices
    Dim objDppApi As Long           ' pointer to dpp api
    Dim szStatus As String * 2000   ' status text
    Dim DataBuffer(8192) As Long    ' spectrum data
    Dim NumChan As Integer          ' number of acquired channels
    Dim SelDevNum As Integer

    If (Len(Trim(txtDevNum.Text)) > 0) Then
        SelDevNum = Val(txtDevNum.Text)
        If ((SelDevNum < 1) Or (SelDevNum > iNumDevices)) Then
            MsgBox "Bad device number selected.", vbInformation
            cmdGetData.Enabled = True
            Exit Sub
        End If
    Else
        MsgBox "No devices selected.", vbInformation
        cmdGetData.Enabled = True
        Exit Sub
    End If
    
    objDppApi = OpenDppApi() ' create/open DPPAPI
    numdev = OpenUSBDeviceEx(objDppApi, SelDevNum) ' open USB communications
    If (numdev > 0) Then
        GetStatusString objDppApi, 1, szStatus, 2000 ' get device status
        'Run GetStatusStruct or GetStatusString before running Get80MHzMode
        SetDppApiGlobalVars objDppApi, SelDevNum
        txtStatus = szStatus
        GetConfigFromDpp objDppApi ' configure from hardware
        NumChan = GetDppData(objDppApi, VarPtr(DataBuffer(0))) ' acquire data
        Dim varPlotData As Variant
        varPlotData = ConvertDataToBuffer(NumChan, DataBuffer())
        Dim clsDataPlot As New clsPlotSpectrum
        clsDataPlot.PlotDataFromBuffer varPlotData, picPlot
    End If
    CloseUSBDevice (objDppApi) ' close usb
    CloseDppApi (objDppApi) ' close DPPAPI
    Sleep (750)
    cmdGetData.Enabled = True
End Sub

Private Sub cmdGetDevices_Click()
    cmdGetDevices.Enabled = False   ' disable button until done
    Dim numdev As Integer           ' number of usb devices
    Dim Res As Integer              ' number of usb devices
    Dim objDppApi As Long           ' pointer to dpp api
    Dim strStatus As String         ' status text
    Dim iDeviceType As Integer      ' number of acquired channels
    Dim SerNum As Long
    Dim i As Long
    Dim strDeviceType As String
    
    objDppApi = OpenDppApi()        ' create/open DPPAPI
    numdev = OpenUSBDevice(objDppApi) ' open communications default USB device
    CloseUSBDevice (objDppApi)                                      ' close usb default device
    If (numdev > 0) Then
        strStatus = ""
        iNumDevices = numdev
        For i = 1 To numdev
            Res = OpenUSBDeviceEx(objDppApi, i)                     ' open selected USB device
            iDeviceType = GetUSBDppDeviceInfo(objDppApi, i, SerNum) ' get device information
            strDeviceType = DPPTypeString(iDeviceType)
            strStatus = strStatus & Str(i) & " " & "[" & strDeviceType & "] " & Str(SerNum) & vbNewLine
            CloseUSBDevice (objDppApi) ' close usb
        Next
    End If
    txtStatus = strStatus
    CloseDppApi (objDppApi) ' close DPPAPI
    Sleep (750)
    cmdGetDevices.Enabled = True
End Sub

Private Sub Form_Load()
    iNumDevices = 0
    txtDevNum.Text = 0
    cmdGetData.Enabled = False
End Sub

Private Sub txtStatus_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim strIDs As String
    Dim iPos As Long
    Dim i As Long
    Dim LineNum As Long
    
    If (iNumDevices < 1) Then Exit Sub
    If (Len(Trim(txtStatus.Text)) = 0) Then Exit Sub
    strIDs = txtStatus.Text
    iPos = txtStatus.SelStart
    LineNum = 1
    If (iPos > 0) Then
        txtDevNum.Text = Len(Mid(strIDs, iPos))
        If (Len(Mid(strIDs, iPos)) = 1) Then  'overshoot
            LineNum = 0
        End If
    End If
    strIDs = Left(strIDs, iPos)
    iPos = 1
    For i = 1 To Len(strIDs)
        iPos = InStr(iPos, strIDs, vbNewLine)
        If (iPos > 0) Then
            iPos = iPos + Len(vbNewLine)
            LineNum = LineNum + 1
        Else
            Exit For
        End If
    Next
    If ((LineNum > 0) And (LineNum <= iNumDevices)) Then
        txtDevNum.Text = LineNum
        cmdGetData.Enabled = True
    Else
        txtDevNum.Text = 0
        cmdGetData.Enabled = False
    End If
End Sub































